//
//  stackImpl.h
//  ADT
//
//  Created by Klaus Ahrens on 03.12.12.
//  Copyright (c) 2012 Klaus Ahrens. All rights reserved.
//

#ifndef stackImpl_h
#define stackImpl_h

#include <memory>

class Stack::Impl {
    std::unique_ptr<int[]> data;
    int idx, max;
public:
    Impl():data{new int[100]}, idx{0}, max{100} {}
    void push(int i){if(idx<max) data[idx++]=i;}
    int top(){if (idx>0) return data[idx-1];}
    void pop(){--idx;}
};

#endif
