//
//  stack.h
//  ADT
//
//  Created by Klaus Ahrens on 03.12.12.
//  Copyright (c) 2012 Klaus Ahrens. All rights reserved.
//

#ifndef stack_h
#define stack_h

#include <memory>

class Stack {
    class Impl;
    std::unique_ptr<Impl> impl; // completely hidden
public:
    Stack();
    ~Stack();
    void push(int i);
    int top();
    void pop();
};


#endif
